global IDiv64 :label;
global UDiv64 :label;


begin text

//     2   - DivPos  UDiv
// gr7   0
<DivPos>    //  
    gr4 = gr2 - gr0;
    gr5 = gr3 - gr1 - 1 + carry;
    if u< delayed skip UDiv
        with gr4 - gr0;
    with gr5 - gr1 - 1 + carry;
    nul;
    // cond. skip UDiv
    if u< skip UDiv;
<L1>
    gr0 <<= 1;
    gr1 C<<= 1;
    gr4 = gr2 - gr0;
    gr5 = gr3 - gr1 - 1 + carry;
    with gr4 - gr0;
    with gr5 - gr1 - 1 + carry;
    if u>= skip L1
        with gr7++;

<UDiv>      //    .
            //     
    gr4 = false;
    gr5 = false;    //   
<PosLoop>
    with gr2 - gr0;
    with gr3 - gr1 - 1 + carry;
    if u< delayed skip L3;  //    ,  
    gr4 C<<= 1;     //   -   
    gr5 C<<= 1;
    // cond. skip L3
    gr2 = gr2 - gr0;
    gr3 = gr3 - gr1 - 1 + carry;
<L3>
    gr7--;
    if >= delayed skip PosLoop;
    gr1 >>= 1;
    gr0 C>>= 1;
    // cond. skip PosLoop
    return;

<IDiv64>
    ar5 = sp;
    push ar1, gr1;
    ar1, gr1 = [ ar5 -= 4 ];     //   
    push ar0, gr0;
    gr0 = ar1;        //   
    push ar2, gr2
        with gr0 or gr1;
    push ar3, gr3;
    if =0 delayed skip ZeroDivide;
    ar3, gr3 = [ --ar5 ];        //   
    gr2 = ar3;        //   
    push ar6, gr6
        with gr6 = gr1 xor gr3;
    if >= skip L4
        with gr7 = false;
    gr0 = gr7 - gr0;
    gr1 = gr7 - gr1 - 1 + carry;
<L4>
    push ar4, gr4
        with gr3;
    push ar5, gr5;
    if < skip Neg;
    callrel DivPos;
    with gr6;
<Res>
    if >= skip L5
        with gr7 = false;
    gr4 = gr7 - gr4;
    gr5 = gr7 - gr5 - 1 + carry;
<L5>
    [ ar5 += 3 ] = gr5;
    [ --ar5 ] = gr4;
    pop ar5, gr5;
    pop ar4, gr4;
    pop ar6, gr6;
    pop ar3, gr3;
    pop ar2, gr2;
    pop ar0, gr0;
    pop ar1, gr1;
    return;

<Neg>   //   
    gr4 = gr2 - gr0;
    gr5 = gr3 - gr1 - 1 + carry;
    if >= delayed skip NDiv
        with gr0 - gr4;
    with gr1 - gr5 - 1 + carry;
    nul;
    // cond. skip NDiv
    if < skip NDiv;
<Loop2>
    gr0 <<= 1;
    gr1 C<<= 1;
    gr4 = gr2 - gr0;
    gr5 = gr3 - gr1 - 1 + carry;
    with gr0 - gr4;
    with gr1 - gr5 - 1 + carry;
    if >= skip Loop2
        with gr7++;

<NDiv>            //    
    gr4 = false;
    gr5 = false;
<NegLoop>
    with gr0 - gr2;
    with gr1 - gr3 - 1 + carry;
    if < delayed skip L7;
    gr4 <<= 1;
    gr5 C<<= 1;
    // cond. skip L7
    gr2 = gr2 - gr0;
    gr3 = gr3 - gr1 - 1 + carry;
    gr4++;
    gr5 = gr5 + carry;
<L7>
    gr7--;
    if >= delayed skip NegLoop;
    gr1 A>>= 1;
    gr0 C>>= 1;
    // cond. skip NegLoop
    skip Res
        with gr6;
<ZeroDivide>
    pop ar3, gr3;
    pop ar2, gr2;
    pop ar0, gr0;
    pop ar1, gr1;
    return;

<UDiv64>
    ar5 = sp;
    push ar1, gr1;
    ar1, gr1 = [ ar5 -= 4 ];
    push ar0, gr0;
    gr0 = ar1;
    push ar2, gr2
         with gr0 or gr1;
    push ar3, gr3;
    if =0 delayed skip ZeroDivide;
    ar3, gr3 = [ --ar5 ]
        with gr7 = false;
    gr2 = ar3;
    push ar4, gr4;
    push ar5, gr5;
    callrel DivPos;
<L9>
    [ ar5 += 3 ] = gr5;
    [ --ar5 ] = gr4;
    pop ar5, gr5;
    pop ar4, gr4;
    pop ar3, gr3;
    pop ar2, gr2;
    pop ar0, gr0;
    pop ar1, gr1;
    return;

end text;
