//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                           fcmp.asm                                       //
//                                                                          //
//   float .                                           //
// FCmp -  float       PSW     //        
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// : 
// : 01 ( 27.11.97 )
// : 
// :

global FCmp :label;

extern FFrExp :label;

begin text

//=================  FCmp ======================
//     . 32- 
//  :     .
// +0 = SP    
// -1 = PSW
// -2 = PC
// -3 =  , float 32 
// -4 =  , float 32 
//
//  : PSW -   :
//               == 1    ( ).
//              C == 0      
//              N  Z,    .  
//                   :
//                Z == 1  
//                N == 1     ( )
//            gr7 -    :
//              ( 0,  0,  0)    with gr7,
//                 N  Z     .
// : ar5, gr7
<FCmp>
    ar5 = sp;
    push ar0, gr0;
    push ar1, gr1;
    push ar2, gr2;
    ar1, gr1 = [ ar5 -= 4 ];
    gr0 = ar1;
    push ar0, gr0;
    call FFrExp;
    push ar1, gr1
        with gr2 = gr7;
    call FFrExp;
    with gr2 or gr7;
    if < delayed skip Unordered
        with gr0 xor gr1;   //  
    pop ar1, gr1
        with gr7 = gr0 noflags;
    pop ar0, gr0;
    // cond. skip Unordered
    if < skip Signs
        with gr0 = gr0 - gr1;    //  
    if <>0 skip Exps;
    gr0 = ar0;
    gr1 = ar1;
    pop ar2, gr2
        with gr0 = gr0 - gr1;
    pop ar1, gr1
        with gr7 = gr0 xor gr7 noflags;
    pop ar0, gr0;
    if <>0 return
        with gr7;
    return
        with gr7 = false;
<Signs>                     //  
        // ,     
    gr0 = ar0;
    gr1 = ar1;
    pop ar2, gr2
        with gr0 or gr1;
    pop ar1, gr1;
    pop ar0, gr0;
    if <>0 return
        with gr7;
    return
        with gr7 = false;   // -0 = +0
<Exps>          //  
    pop ar2, gr2
        with gr7 = gr0 xor gr7;
    pop ar1, gr1;
    pop ar0, gr0;
    return;
<Unordered>
    pop ar2, gr2
        with gr7 = true;
    pop ar1, gr1
        with gr7 <<= 1;
    pop ar0, gr0;
    return;

end text;

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                         fadd.asm                               //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
