//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                           mod32.asm                                      //
//                                                                          //
//        32-                   //
//   IMod32 -                                  //
//   UMod32 -                                  //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// : 
// : 02 ( 27.11.97 )
// : 
// :   2     . 
//     .

global IMod32 :label;
global UMod32 :label;


begin text

//=====  UMod32 ========
//     32- 
//    .
//  :     .
// +0 = SP    
// -1 = ,  32 
// -2 = ,  32 
// -3 = PSW
// -4 = PC
//
//  : gr7 - 
// : ar5
<UMod32>
        //   gr5   gr7
        //   
    pop ar5,gr5 with gr7 = gr5;         // ar5 - , gr5 - 

    push ar0,gr0 with gr0 = gr5;        // gr0 - 
    gr7 = ar5 with gr5 = gr7 noflags;   // gr7 - 

    if =0 delayed skip Over;
    push ar2, gr2 with gr2 = false noflags;
    nul;

<ModPos>
    push ar1, gr1
        with gr1 = gr7 - gr0;
    if u< skip Div      //   
        with gr1 - gr0;
    if u< skip Div;     //    
<Loop0>
    gr0 <<= 1;
    gr1 = gr7 - gr0;
    with gr1 - gr0;
    if u>= skip Loop0
        with gr2++;

<Div>        // 
    pop ar1, gr1
        with gr7 - gr0;
<PDivLoop>
    if u< skip L8
        with gr2--;
    gr7 -= gr0 noflags;
<L8>
    if >= delayed skip PDivLoop
        with gr0 >>= 1;
    with gr7 - gr0;
    nul;
    // cond. skip PDivLoop
    pop ar2, gr2;
    pop ar0, gr0;
    return;


//=====  IMod32 ========
//     32- 
//    .
//  :     .
// +0 = SP    
// -1 = ,  32 
// -2 = ,  32 
// -3 = PSW
// -4 = PC
//
//  : gr7 - 
// : ar5
<IMod32>

        //   gr5   gr7
        //   
    pop ar5,gr5 with gr7 = gr5;         // ar5 - , gr5 - 

    push ar0,gr0 with gr0 = gr5;        // gr0 - 
    gr7 = ar5 with gr5 = gr7 noflags;   // gr7 - 
    
    if =0 delayed skip Over 
        with gr0 xor gr7;
    push ar2,gr2;
    nul;
        // if delayed skip Over

    if >= skip L4
        with gr7;
    gr0 = -gr0 noflags;
<L4>
    if >= delayed skip ModPos;  // 
    gr2 = false;
    nul;
    // cond. skip ModPos
    push ar1, gr1
        with gr1 = gr7 - gr0;
    if >= skip NDiv
        with gr1 - gr0;
    if > skip NDiv;
<Loop2>
    gr0 <<= 1;
    gr1 = gr7 - gr0;
    with gr1 - gr0;
    if v<= skip Loop2       // correct Ch.A. for break infinite loop
        with gr2++;	        // when 80000000h mod 2
<NDiv>
    pop ar1, gr1
        with gr0 - gr7;
<NDivLoop>
    if < skip L1
        with gr2--;
    gr7 -= gr0 noflags;
<L1>
    if >= delayed skip NDivLoop
        with gr0 A>>= 1;
    with gr0 - gr7;
    nul;
    // cond. skip NDivLoop
<Over>
    pop ar2, gr2;
    pop ar0, gr0;
    return;

end text;

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                         div32.asm                              //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

