//////////////////////////////////////////////////////////////////////////
//                                                                      //
// auxfd.h -                                                            //
//                                                                      //
//          ,       //
//        .                         //
//                                                                      //
// Copyright (c) 2001-2008 RC Module                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 2     $      $Date:: 2/01/08 1:56p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#ifndef _FPIEEE_Overflow
//	   
//#define _FPIEEE_Overflow	1
//#define _FPIEEE_Underflow	2
//#define _FPIEEE_Invalid	4
//#define _FPIEEE_TLoss		8

//	    rtmacro
#define _FPIEEE_Invalid		1
#define _FPIEEE_DivByZero	2
#define _FPIEEE_Overflow	4
#define _FPIEEE_Underflow	8
#define _FPIEEE_Inexact		16
#define _FPIEEE_TLoss		32

//LONG = nmcc long = ms __int64
#if defined(NM6403) || defined(NM6404) || defined(NM6405)
	typedef long LONG;
	typedef unsigned long ULONG;
#else
#if defined(__NM6403__) || defined(__NM6405__)
	typedef long LONG;
	typedef unsigned long ULONG;
#else
	typedef __int64 LONG;
	typedef unsigned __int64 ULONG;
#endif  // defined(__NM6403__) || defined(__NM6405__)
#endif  // defined(NM6403) || defined(NM6404) || defined(NM6405)

#define max(x, y) (((x)>=y) ? (x) : (y))

#ifdef __cplusplus
extern "C" {
#endif  // __cplusplus

extern unsigned int _FPIEEE_Flags;	//	   
inline int _FPIEEE_Signal(int i) 	//	 
		{ return _FPIEEE_Flags|=(i);}

//inline int abs(int _x) {return _x>=0 ? _x : -_x; }
//inline LONG abs(LONG _x) {return _x>=0 ? _x : -_x; }

//	/ float&double,  !

void DestructFloat(float, int&, int&, int&, int&);
void DstrDouble(double, LONG&, int&, int&);

float ConstructFloat(int, int, int Sign = 0, int Special = 0);
double ConstructDouble(LONG, LONG, LONG, int Special = 0);

#ifdef __cplusplus
}
#endif  // __cplusplus

#endif  // _FPIEEE_Overflow
